/*****************************************************************
 * Copyright (c) ParaSoft Corporation 1991.  All rights reserved.*
 * THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF ParaSoft       *
 * The copyright notice above does not evidence any              *
 * actual or intended publication of such source code.           *
 *****************************************************************/

#include "extern.h"

#define STATE_OUT		0
#define STATE_PROGRAM	1
#define STATE_USE		2
#define STATE_IMPLICIT	3
#define STATE_PARAMETER	4
#define STATE_DECL		5
#define STATE_EXEC		6
#define STATE_CONTAINS	7
#define STATE_INTERNAL	8
#define STATE_END		9

#define CLASS_PROGRAM			 0
#define CLASS_USE				 1
#define CLASS_IMPLICIT_NONE		 2
#define CLASS_FORMAT			 3
#define CLASS_IMPLICIT			 4
#define CLASS_PARAMETER			 5
#define CLASS_DATA				 6
#define CLASS_DECL				 7
#define CLASS_EXEC				 8
#define CLASS_CONTAINS			 9
#define CLASS_MODULE			10
#define CLASS_END				11
#define CLASS_IGNORE			12

static int *class;

int state [MAX_STATE] = {STATE_OUT};
int scoping_unit [MAX_STATE] = {UNIT_OUT};
int state_level = 0;

Node *se_unit_stmt;

static int low [] = {  /* state set uppon entry on class */
	1, 2, 3, 3, 4, 4, 5, 5, 6, 7, 8, 9
};

static int upp [] = {  /* maximum state in which class is allowed */
	1, 2, 3, 6, 4, 5, 6, 5, 6, 7, 8, 9
};
	
static int program_units = 0;  /* program units in file */

static int temp_not_written_decl = 1;
static int temp_not_written_init = 1;

order_init ()  /* initializes internal stuff */
{
	int i;
	char *symbol;

	class = (int*) U_malloc (LAST_TOKEN * sizeof (int));

	for (i = 0; i < LAST_TOKEN; i++)
		class[i] = -1;

	class[IGNORE_STMT] =
	class[INCLUDE_STMT] = CLASS_IGNORE;

	class[PROGRAM_STMT] =
	class[SUBROUTINE_STMT] =
	class[FUNCTION_STMT] =
	class[MODULE_STMT] =
	class[BLOCK_DATA_STMT] = CLASS_PROGRAM;

	class[USE_STMT] = CLASS_USE;

	class[IMPLICIT_NONE_STMT] = CLASS_IMPLICIT_NONE;

	class[FORMAT_STMT] =
	class[ENTRY_STMT] = CLASS_FORMAT;

	class[IMPLICIT_STMT] = CLASS_IMPLICIT;

	class[PARAMETER_STMT] = CLASS_PARAMETER;

	class[DATA_STMT] = CLASS_DATA;

	class[TYPE_DECLARATION_STMT] =
	class[PRIVATE_SEQUENCE_STMT] =
	class[INTERFACE_STMT] =
	class[END_INTERFACE_STMT] =
	class[ACCESS_STMT] =
	class[ALLOCATABLE_STMT] =
	class[COMMON_STMT] =
	class[DIMENSION_STMT] =
	class[EQUIVALENCE_STMT] =
	class[EXTERNAL_STMT] =
	class[INTENT_STMT] =
	class[INTRINSIC_STMT] =
	class[NAMELIST_STMT] =
	class[OPTIONAL_STMT] =
	class[POINTER_STMT] =
	class[SAVE_STMT] =
	class[TARGET_STMT] =
	class[DERIVED_TYPE_STMT] =
	class[END_TYPE_STMT] =
/* ##BEG##, 9/24/91, SHU */
	class[DIRECTIVE_STMT] =

/* ##END## */

	class[STMT_FUNCTION_STMT] =
	class[COMPONENT_DEF_STMT] = CLASS_DECL;

	class[ASSIGNEMENT_STMT] =
	class[CALL_STMT] =
	class[CLOSE_STMT] =
	class[COMPUTED_GOTO_STMT] =
	class[END_FILE_STMT] =
	class[BACKSPACE_STMT] =
	class[INQUIRE_STMT] =
	class[GOTO_STMT] =
	class[IF_STMT] =
	class[IF_THEN_STMT] =
	class[ELSE_IF_STMT] =
	class[ELSE_STMT] =
	class[END_IF_STMT] =
	class[DO_STMT] =
	class[OPEN_STMT] =
	class[PRINT_STMT] =
	class[READ_STMT] =
	class[RETURN_STMT] =
	class[REWIND_STMT] =
	class[STOP_STMT] =
	class[WRITE_STMT] =
	class[ARITHMETIC_IF_STMT] =
	class[ASSIGN_STMT] =
	class[ASSIGNED_GOTO_STMT] =
	class[PAUSE_STMT] =
	class[ALLOCATE_STMT] =
	class[NULLIFY_STMT] =
	class[DEALLOCATE_STMT] =
	class[POINTER_ASSIGNEMENT_STMT] =
	class[WHERE_STMT] =
	class[WHERE_CONSTRUCT_STMT] =
	class[WHERE_CONSTRUCT] =
	class[SELECT_CASE_STMT] =
	class[CASE_STMT] =
	class[END_SELECT_STMT] =
	class[EXIT_STMT] =
	class[CYCLE_STMT] =
	class[ELSEWHERE_STMT] =
	class[END_WHERE_STMT] =
	class[CONTINUE_STMT] =
	class[END_DO_STMT] =
	class[DUM_STMT] =
	class[IF_CONSTRUCT] = 
	class[DO_CONSTRUCT] = 
	class[CASE_CONSTRUCT] = 
	class[FORALL_STMT] = CLASS_EXEC;
 
	class[CONTAINS_STMT] = CLASS_CONTAINS;

	class[MODULE_PROCEDURE_STMT] = CLASS_MODULE;

	class[END_STMT] =
	class[END_PROGRAM_STMT] =
	class[END_MODULE_STMT] =
	class[END_BLOCK_DATA_STMT] =
	class[END_FUNCTION_STMT] =
	class[END_SUBROUTINE_STMT] = CLASS_END;

#ifdef CHECK
	for (i = 0; i < LAST_TOKEN; i++) {
		symbol = node_Symbol (i);
		if (symbol != (char*) 0 && strlen (symbol) > 4
		&& !strncmp (&(symbol [strlen (symbol) - 4]), "Stmt", 4)
		&& class [i] == -1) {
			sprintf (serr, "define class for Stmt: %s", symbol);
			syserr (serr);
		}
	}
#endif
}


int order_is_exec (type)
int type;
{
	if (class [type] == CLASS_EXEC || class [type] == CLASS_END)
		return 1;
	else
		return 0;
}

int state_old;

PtF order (node)
Node *node;
{
	int type, class_type;

	if (node == NN || class [node->com.type] == CLASS_IGNORE)
		return (PtF) 0;

	if (node->com.type == DUM_STMT)
		type = node->DumStmt.Stmt->com.type;
	else
		type = node->com.type;

	if (se_after_select == 0 && type == SELECT_CASE_STMT)
		se_after_select = 1;
	else if (se_after_select && type != CASE_STMT && type != END_SELECT_STMT)
		fatal ("wrong statement ordering: SELECT statement must be followed by CASE");

	class_type = class [type];

	if (class_type == -1) {
		if (current_pass == PASS_PARSE) {
			sprintf (serr, "not a Stmt: '%s'", node_Symbol (type));
			syserr (serr);
		}
		return (PtF) 0;
	}

	if (se_in_interface)
		if (type == ENTRY_STMT || type == FORMAT_STMT || type == CONTAINS_STMT
		|| class_type == CLASS_EXEC) {
			sprintf (serr, "statement '%s' not allowed in INTERFACE body"
			, node_Symbol (type));
			fatal (serr);
		}

	if (upp [class_type] < state [state_level]) {
		if (current_pass == PASS_PARSE)
			fatal ("wrong statement ordering");  /* E_2_5 (Figure 2.1) */
		return (PtF) 0;
	}

	state_old = state [state_level];
	if (state [state_level] < low [class_type])
		state [state_level] = low [class_type];

/* call functions depending on the swithching of states */

	if (state [state_level] != state_old) {  /* no swithching of states */
		if (state_old <= STATE_OUT
		&& state [state_level] >= STATE_PROGRAM) {/* entering scoping_unit */
			if (current_pass == PASS_PARSE)
				if (scoping_unit [state_level] != UNIT_OUT)
					fatal ("missing END statement");

			switch (type) {

			case FUNCTION_STMT:
				scoping_unit [state_level] = UNIT_FUNCTION;
				se_unit_stmt = node;
				break;

			case SUBROUTINE_STMT:
				scoping_unit [state_level] = UNIT_SUBROUTINE;
				se_unit_stmt = node;
				break;

			case BLOCK_DATA_STMT:
				scoping_unit [state_level] = UNIT_BLOCK_DATA;
				se_unit_stmt = node;
				break;

			case MODULE_STMT:
				scoping_unit [state_level] = UNIT_MODULE;
				se_unit_stmt = node;
				break;

			default:
				scoping_unit [state_level] = UNIT_PROGRAM;
				se_unit_stmt = NN;
				if (program_units++ && current_pass == PASS_PARSE)
					fatal ("too many PROGRAM units");  /* E_2_1_7 */
			}

			if (type == PROGRAM_STMT)
				se_unit_stmt = node;
		}

		if (state_old <= STATE_DECL && state [state_level] >= STATE_EXEC) {
			switch (current_pass) {

			case PASS_PARSE:
				order_enddecl_parse ();
				break;

			case PASS_WRITE:
				temp_decl ();
				order_enddecl_write ();
				break;

			default:
				 SYSERR;
			}
		}
	}

/* check for statements allowed in scoping units *//* E_2_5 (Table 2.1) */

	if (current_pass == PASS_PARSE) {
		switch (scoping_unit [state_level]) {
		case UNIT_PROGRAM:
			if (type == ENTRY_STMT)
				fatal ("ENTRY statement not allowed in PROGRAM unit");
			else if (type == RETURN_STMT)
				fatal ("RETURN statement not allowed in PROGRAM unit");
			break;
		case UNIT_BLOCK_DATA:
			if (type == ENTRY_STMT || type == FORMAT_STMT
			|| class_type == CLASS_EXEC) {
				sprintf (serr, "statement '%s' not allowed in BLOCK DATA unit"
				, node_Symbol (type));
				fatal (serr);
			}
			break;
		}
	}

/* reset on EndStmts */

	if (state [state_level] == STATE_END)
		order_reset_states ();

/* checks for obsolescent Stmt */

	if (current_pass == PASS_PARSE)
		switch (type) {
			case ARITHMETIC_IF_STMT:  /* E_2_3_13 */
			case ASSIGN_STMT:         /* E_2_3_14 */
			case ASSIGNED_GOTO_STMT:  /* E_2_3_15 */
			case PAUSE_STMT:          /* E_2_3_16 */
				if (current_pass == PASS_PARSE)
					obsol (node_Symbol (type));
		}	

	return (PtF) 0;
}

order_reset_states ()
{
	scoping_unit [state_level] = UNIT_OUT;
	state [state_level] = STATE_OUT;
}

order_enddecl_parse ()  /* called at the end of the declaration section, during parsing  */
{
	implicit_enddecl ();
	interf_enddecl ();
	auto_enddecl ();
	decl_initexpr_parse ();
}

order_enddecl_write ()
{
	ostart ();
	prot_init (); 
	temp_init ();
	oend ();
	ostart ();
	ac_enddecl_write ();
	oend ();
	block_write_sta_init ();
}

proc_end_before_write ()  /* called at the end of every program unit */
{
/* this commented temporary for transfer assignment to forall */
/*	array_end (); */ /* must be before name_end */
 /* BOZKUS */
	llb_end ();  /* must be before name_end */
	lub_end ();  /* must be before name_end */
 /* END */
	auto_end ();   /* must be before name_end, opt_end, desc_end */
	opt_end ();    /* must be before name_end */
/*
	desc_end ();
*/
	fun_end ();    /* must be before name_end */
	cubix_end ();
	name_end ();

	label_end ();

	if (!se_in_interface)
		block_add_sta_check ();
}

/*
This procedure should leave things as they were at the beginning of the
program, apart from leaving the globals in the table.
*/

proc_end_after_write ()  /* called at the end of every program unit */
{
	table_end ();
	implicit_end ();
	temp_end ();
	array_end_after_write ();

	cubix_end_write ();
	decl_intrin_end_write ();
	ac_end_write ();

	if (!se_in_interface)
		block_add_sta_clear ();

/* for the next ones doesn't matter the order (for sure) */

	case_end_write ();
}

order_is_action_stmt (type)  /*!!! Implement using page 2-2 of F90 */
{
	switch (type) {

	case ALLOCATE_STMT:
	case ASSIGNEMENT_STMT:
	case BACKSPACE_STMT:
	case CALL_STMT:
	case CLOSE_STMT:
	case COMPUTED_GOTO_STMT:
	case CONTINUE_STMT:
	case CYCLE_STMT:
	case DEALLOCATE_STMT:
	case END_FILE_STMT:
	case END_FUNCTION_STMT:
	case END_PROGRAM_STMT:
	case END_SUBROUTINE_STMT:
	case EXIT_STMT:
	case GOTO_STMT:
	case IF_STMT:
	case INQUIRE_STMT:
	case NULLIFY_STMT:
	case OPEN_STMT:
	case POINTER_ASSIGNEMENT_STMT:
	case PRINT_STMT:
	case READ_STMT:
	case RETURN_STMT:
	case REWIND_STMT:
	case STOP_STMT:
	case WHERE_STMT:
	case WRITE_STMT:
	case ARITHMETIC_IF_STMT:
	case ASSIGN_STMT:
	case ASSIGNED_GOTO_STMT:
	case PAUSE_STMT:
		return 1;

	default:
		return 0;
	}
}

order_is_construct (type)
{
	switch (type) {

	case DO_CONSTRUCT:
	case IF_CONSTRUCT:
	case WHERE_CONSTRUCT:
	case CASE_CONSTRUCT:
		return 1;

	default:
		return 0;
	}
}
